package history

import (
	"github.com/rs/zerolog"
	"kumoly.io/kumoly/app/store"
	"kumoly.io/kumoly/app/util"
)

type Service struct {
}

var l zerolog.Logger

func (srv Service) GetName() string           { return "history.Service" }
func (srv Service) IsService() bool           { return true }
func (srv Service) GetDependencies() []string { return []string{"server.Service"} }

func (srv Service) Init() error {
	l = util.Klog.With().Str("mod", "history").Logger()
	l.Debug().Msg("Migrating database for history.Service ...")
	if err := store.Migrate(&History{}); err != nil {
		l.Error().Err(err).Msg("Migrating database")
		return err
	}
	return nil
}
func (srv Service) Main() error {
	Start(DBReceiver)
	return nil
}
func (srv Service) Del() {
	Stop()
}

func (srv Service) Load() error   { return nil }
func (srv Service) Health() error { return nil }
